package lazabs

import lazabs.prover.Prover
import lazabs.ast.ASTree._
import lazabs.viewer.ScalaPrinter

object Main {
  def askPrincess(e:Expression) = {
    println("Asking Princess about the satisfiability of formula " + ScalaPrinter(e))
    Prover.isSatisfiable(e) match {
      case None => println("Princess doesn't know")
      case Some(true) => println("Princess thinks it is satisfiable")
      case Some(false) => println("Princess thinks it is unsatisfiable")
    }
  }

  def main(args: Array[String]) {
    val formula = Not(Existential(BinderVariable("y"),GreaterThan(Variable("y"),NumericalConst(3))))
    askPrincess(formula)
  }
}
