package lazabs.utils

import lazabs.ast.ASTree._
import lazabs.types._


/**
 * manipulates a formula 
 *
 */
object Manip {
  /*
   * short circuits a boolean formula
   */
  def shortCircuit(e: Expression): Expression = e match {
    case Not(exp) => Not(shortCircuit(exp))   
    case Not(Not(exp)) => shortCircuit(exp) //eliminate double negations.
    case Equality(exp1,exp2) => Equality(shortCircuit(exp1),shortCircuit(exp2))
    case Inequality(exp1,exp2) => Inequality(shortCircuit(exp1),shortCircuit(exp2))
    TO_COMPLETE
    case _ => e
  }

 def freeVars(f: Expression): Set[Variable] = {
   def fv(f: Expression, boundVars: List[String]): Set[Variable] = f match {
     case BinaryExpression(e1, op, e2) => fv(e1, boundVars) ++ fv(e2, boundVars)
     TO_COMPLETE
   }
   fv(f, List[String]())
 }
}
